#include <errno.h>
#include <stdarg.h>
#include <unistd.h>

#define MAX_ARGS 100

int execlp(const char *file, const char *arg, ...)
{
	va_list ap;
	char *argv[MAX_ARGS];
	int n;

	n = 0;
	argv[n] = (char *)arg;
	va_start(ap, arg);
	while (argv[n] != NULL) {
		if (n >= MAX_ARGS) {
			errno = E2BIG;
			return -1;
		}
		argv[++n] = va_arg(ap, char *);
	}
	va_end(ap);
	return execvp(file, argv);
}
