#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define MAXARGS 100
#define MAXPATH 256

char *nextpath(const char **paths, const char *file);
int execvp(const char *file, char *const *argv)
{
	const char *paths, *path;
	char *argv2[MAXARGS];
	int n;

	path = file;
	if (strchr(path, '/') == NULL) {
		paths = getenv("PATH");
		if (paths == NULL)
			paths = "/bin:/usr/bin";
		while ( (path = nextpath(&paths, file)) ) {
			if (access(path, X_OK) == 0)
				break;
		}
		if (path == NULL) {
			errno = ENOENT;
			return -1;
		}
	}
	execv(path, argv);
	/* PWB addition: if direct execution failed, try to
	 * pass it as a script to the shell
	 */
	argv2[0] = "sh";
	argv2[1] = (char *)path;
	for (n = 2; argv[n-1] != NULL; n++) {
		if (n >= MAXARGS) {
			errno = E2BIG;
			return -1;
		}
		argv2[n] = argv[n-1];
	}
	execv("/bin/sh", argv2);
	return -1;
}
