#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <malloc.h>

int file_read(FILE *f, char *c, size_t s)
{
	return read(f->fd, c, s);
}

int file_write(FILE *f, const char *c, size_t s)
{
	return write(f->fd, c, s);
}

int file_seek(FILE *f, long off, int whence)
{
	return lseek(f->fd, off, whence);
}

FILE *fopen(const char *path, const char *mode)
{
	int m;
	FILE *f;

	if (strcmp(mode, "r") == 0) {
		m = O_RDONLY;
	} else if (strcmp(mode, "w") == 0) {
		m = O_WRONLY | O_CREAT | O_TRUNC;
	} else if (strcmp(mode, "a") == 0) {
		m = O_WRONLY | O_CREAT | O_APPEND;
	} else if (strcmp(mode, "r+") == 0) {
		m = O_RDWR;
	} else if (strcmp(mode, "w+") == 0) {
		m = O_RDWR | O_CREAT | O_APPEND;
	} else if (strcmp(mode, "a+") == 0) {
		m = O_RDWR | O_CREAT | O_APPEND;
	} else {
		return NULL;
	}
	if ( (f = malloc(sizeof(*f))) == NULL )
		return NULL;
	if ( (f->fd = open(path, m, 0666)) < 0 ) {
		free(f);
		return NULL;
	}
	f->lastc = -1;
	f->read = file_read;
	f->write = file_write;
	f->seek = file_seek;
	return f;
}
