#include <stddef.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

int inet_pton(int af, const char *src, void *dst)
{
	char buf[4];
	struct in_addr in;
	unsigned int n, tmp;
	int i, j;

	if (af != AF_INET)
		goto error;

	tmp = 0;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 3; j++) {
			if (!isdigit(src[j]))
				break;
			buf[j] = src[j];
		}
		if (!j || (i < 3 && src[j] != '.') || (i == 3 && src[j] != '\0'))
			goto error;
		buf[j] = '\0';
		n = atoi(buf);
		if (n > 255)
			goto error;
		tmp <<= 8;
		tmp |= n;
		src += j + 1;
	}
	in.s_addr = htonl(tmp);
	memcpy(dst, &in, sizeof(in));
	return 0;

error:
	errno = EAFNOSUPPORT;
	return -1;
}
