#include <stddef.h>
#include <stdarg.h>
#define EOF (-1)
#define _IOFBF 0
#define _IOLBF 1
#define _IONBF 2

struct FILE {
	int fd;
	char *buf;
	size_t pos;
	size_t size;
	int lastc;
	int eof;

	int (*read)(struct FILE *, char *, size_t);
	int (*write)(struct FILE *, const char *, size_t);
	int (*seek)(struct FILE *, long off, int whence);
};

typedef struct FILE FILE;
extern FILE *stdin, *stdout, *stderr;
int printf(const char *fmt, ...);
int fprintf(FILE *f, const char *fmt, ...);
int snprintf(char *buf, size_t len, const char *fmt, ...);
int sprintf(char *buf, const char *fmt, ...);
int vsnprintf(char *buf, size_t len, const char *fmt, va_list ap);
void perror(const char *buf);
FILE *fopen(const char *path, const char *mode);
FILE *fmemopen(void *buf, size_t size, const char *mode);
int fclose(FILE *f);
char *fgets(char *s, int size, FILE *f);
int rename(const char *newpath, const char *oldpath);
int fscanf(FILE *f, const char *fmt, ...);
int fgetc(FILE *f);
int ungetc(int c, FILE *f);
int fileno(FILE *f);
int setvbuf(FILE *f, char *buf, int mode, size_t size);
int setbuf(FILE *f, char *buf);
static inline void clearerr(FILE *f) { f->eof = 0; }
static inline int feof(FILE *f) { return f->eof; }
void rewind(FILE *f);
