#include <stddef.h>
#include <sys/types.h>

int read(int fd, void *buf, size_t len);
int write(int fd, const void *buf, size_t len);
int close(int fd);
int isatty(int fd);
int getuid();
int geteuid();
int pipe(int pipefd[2]);
int fork();
int dup(int fd);
int dup2(int fd1, int fd2);
int chroot(const char *path);
pid_t tcgetpgrp(int fd);
int tcsetpgrp(int fd, pid_t pgrp);
int chdir(const char *path);
int execl(const char *pathname, const char *arg, ...);
int execlp(const char *file, const char *arg, ...);
int execle(const char *pathname, const char *arg, ...);
int execv(const char *pathname, char *const argv[]);
int execvp(const char *file, char *const argv[]);
int execvpe(const char *file, char *const argv[], char *const envp[]);
int execve(const char *file, char *const argv[], char *const envp[]);
pid_t getpid();
int setuid(pid_t uid);
int setgid(gid_t gid);
pid_t setpgid(pid_t p1, pid_t p2);
pid_t setsid();
pid_t getsid(pid_t pid);
int getresuid(uid_t *ruid, uid_t *euid, uid_t *suid);
int link(const char *oldpath, const char *newpath);
int symlink(const char *target, const char *linkpath);
char *getpass(const char *prompt);
int fchown(int fd, uid_t owner, gid_t group);
ssize_t readlink(const char *pathname, char *buf, size_t bufsiz);
int unlink(const char *pathname);
int rmdir(const char *pathname);
pid_t waitpid(pid_t pid, int *wstatus, int options);
#define R_OK 4
#define W_OK 2
#define X_OK 1
#define F_OK 0
int access(const char *path, int mode);
void *brk(void *addr);
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
off_t lseek(int fd, off_t offset, int whence);
int chown(const char *path, uid_t uid, gid_t gid);
int setgroups(int size, gid_t list[]);
struct termios;
int tcgetattr(int fd, struct termios *termios_p);
int tcsetattr(int fd, int actions, const struct termios *termios_p);
unsigned int sleep(unsigned int seconds);
void _exit(int status);
int alarm(unsigned int nsec);
int pause();
