#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>

/* accept either symbolic or numeric uids */

int main(int argc, char *argv[])
{
	uid_t u;
	int i, errors;
	struct stat statbuf;
	struct passwd *pw;

	if (argc < 3) {
		fprintf(stderr, "usage: chown <user/uid> <path>...\n");
		exit(1);
	}

	if ( (pw = getpwnam(argv[1])) ) {
		u = pw->pw_uid;
	} else {
		u = atoi(argv[1]);
	}

	errors = 0;
	for (i = 2; i < argc; i++) {
		if (stat(argv[i], &statbuf) < 0 ||
		    chown(argv[i], u, statbuf.st_gid) < 0) {
			perror(argv[i]);
			errors++;
			continue;
		}
	}
	return errors;
}
