#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* copy multiple files into a destination directory */

int do_cp(const char *src, const char *dst)
{
	int n;
	char buf[4096];
	int ifd, ofd;

	if ( (ifd = open(src, O_RDONLY)) < 0 ) {
		perror(src);
		return 1;
	}

	if ( (ofd = open(dst, O_WRONLY | O_CREAT | O_TRUNC, 0666)) < 0 ) {
		perror(dst);
		return 1;
	}

	while ( (n = read(ifd, buf, 4096)) > 0)
		write(ofd, buf, n);

	return 0;
}

int main(int argc, char* argv[])
{
	struct stat st;
	char name[1024], *p;
	int i;
	int retv = 0;

	if (argc < 3)
		return 1;

	if ( stat(argv[argc - 1], &st) == 0 && S_ISDIR(st.st_mode) ) {
		for (i = 1; i < argc - 1; i++) {
			p = rindex(argv[i], '/');
			if (p == NULL)
				p = argv[i];
			snprintf(name, 1024, "%s/%s", argv[argc - 1], p);
			retv |= do_cp(argv[i], name);
		}
		return retv;
	}
	if (argc == 3)
		return do_cp(argv[1], argv[2]);
	return 1;
}
