#include <stdlib.h>
#include <stdio.h>

/* simplified expr */

void usage(char *name)
{
	fprintf(stderr, "usage: %s <num> +|-|*|/|%% <num>\n", name);
	exit(1);
}

int main(int argc, char* argv[])
{
	long v1, v2;

	if (argc != 4 || argv[2][1] != '\0')
		usage(argv[0]);

	v1 = strtol(argv[1], NULL, 0);
	v2 = strtol(argv[3], NULL, 0);
	switch (argv[2][0]) {
	case '+':
		printf("%ld\n", v1 + v2);
		break;
	case '-':
		printf("%ld\n", v1 - v2);
		break;
	case '*':
		printf("%ld\n", v1 * v2);
		break;
	case '/':
		if (!v2) {
			fprintf(stderr, "expr: division by zero\n");
			exit(1);
		}
		printf("%ld\n", v1 / v2);
		break;
	case '%':
		if (!v2) {
			fprintf(stderr, "expr: division by zero\n");
			exit(1);
		}
		printf("%ld\n", v1 % v2);
		break;
	default:
		usage(argv[0]);
	}
	return 0;
}
