#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <unistd.h>

/*
 * ls with the '-a' option
 *
 * Directory entries that start with '.' are hidden only in the sense that ls
 * doesn't show them by default - they are just regular entries for the kernel.
 */

int main(int argc, char* argv[])
{
	DIR *dir;
	struct dirent* ent;
	int all = 0;

	if (argc > 1)
		if (argv[1][0] == '-' && argv[1][1] == 'a')
			all = 1;

	if ( !(dir = opendir(".")) ) {
		perror(".");
		return 1;
	}

	while ( (ent = readdir(dir)) ) {

		if (ent->d_name[0] == '.' && !all)
			continue;

		printf("%s\n", ent->d_name);
	}

	return 0;
}
