#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

/* support '-p' and create all needed directories in the path */

int do_mkdir(char *path)
{
	char *p, *sep;

	p = path;
	do {
		while (*p == '/')
			p++;
		if ( (sep = strchr(p, '/')) ) {
			*sep = '\0';
			p = sep + 1;
		} else {
			p = strchr(p, '\0');
		}
		errno = 0;
		if (mkdir(path, 0777) < 0) {
			if (errno != EEXIST) {
				perror(path);
				return 1;
			}
		}
		if (sep)
			*sep = '/';
	} while (*p != '\0');

	return 0;
}

int main(int argc, char* argv[])
{
	int i;
	int parent = 0;
	int errors = 0;

	if (argc > 1 && !strcmp(argv[1], "-p")) {
		parent = 1;
		argc--;
		argv++;
	}

	for (i = 1; i < argc; i++) {
		if (parent) {
			errors += do_mkdir(argv[i]);
		} else if (mkdir(argv[i], 0777) < 0) {
			errors++;
			perror(argv[1]);
		}
	}
	return errors;
}
