#include <sys/mount.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/* just a wrapper for the mount system call */

int main(int argc, char *argv[])
{
	const char *fstype, *dev, *mp;

	if (argc < 3 || !strcmp(argv[1], "-t") && argc != 5) {
		fprintf(stderr, "usage: mount [-t fstype] device mountpoint\n");
		exit(1);
	}

	if (!strcmp(argv[1], "-t")) {
		fstype = argv[2];
		dev = argv[3];
		mp = argv[4];
	} else {
		fstype = NULL;
		dev = argv[1];
		mp = argv[2];
	}

	if (mount(dev, mp, fstype, 0, NULL) < 0) {
		perror("mount");
		return 1;
	}
	return 0;
}
