#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/* in Linux, ps just reads pseud-files from /proc */

#define MAX_COMM 100
#define MAXINPUT "100"

int main()
{
	int pid;
	char comm[MAX_COMM + 1];
	DIR *dir;
	struct dirent* ent;
	FILE *f;
	char *delim;

	chdir("/proc");

	if ( !(dir = opendir(".")) ) {
		perror("/proc");
		exit(1);
	}

	printf("PID\tCMD\n");
	while ( (ent = readdir(dir)) ) {
		if (ent->d_name[0] < '0' || ent->d_name[0] > '9')
			continue;
		if (chdir(ent->d_name) < 0)
			continue;
		if ( !(f = fopen("stat", "r")) ) {
			perror("stat");
			continue;
		}
		fscanf(f, "%d (%"MAXINPUT"s ",
			  &pid, comm);
		comm[MAX_COMM] = '\0';
		delim = rindex(comm, ')');
		if (delim != NULL)
			*delim = '\0';
		printf("%d\t%s\n", pid, comm);
		fclose(f);
		chdir("..");
	}

	return 0;
}
