#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>

/* sudo works by being setuid-root. Once it is running as root, it
 * checks sudoers to decide whether to exec your request or not.
 */

int main(int argc, char *argv[])
{
	char buf[16];
	FILE *f;
	struct passwd *pw;

	if (argc < 2) {
		fprintf(stderr, "usage: sudo <cmd> [<args>...]\n");
		return 1;
	}

	if ( (pw = getpwuid(getuid())) == NULL ) {
		fprintf(stderr, "unknown user\n");
		return 1;
	}

	if ( (f = fopen("/etc/sudoers", "r")) == NULL ) {
		perror("/etc/sudoers");
		return 1;
	}
	while ( fgets(buf, 16, f) ) {
		char *p = strchr(buf, '\n');
		if (p)
			*p = '\0';
		if (!strcmp(pw->pw_name, buf)) {
			fclose(f);
			execvp(argv[1], argv + 1);
			perror(argv[1]);
			exit(1);
		}
	}
	fprintf(stderr, "unauthorized\n");
	return 1;
}
