#include <sys/wait.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

pid_t pid;

void alarmh(int signo)
{
	kill(pid, SIGKILL);
}

int main(int argc, char *argv[])
{
	long to;
	int status;

	if (argc < 3) {
		fprintf(stderr, "usage: %s <timeout> <cmd> [<args>...]\n", argv[0]);
		exit(1);
	}
	to = atoi(argv[1]);
	if (to < 0) {
		fprintf(stderr, "%s: negative timeout\n", argv[0]);
		exit(1);
	}
	switch ( (pid = fork()) ) {
	case -1:
		perror(argv[0]);
		exit(125);
		break;
	case 0:
		execvp(argv[2], argv + 2);
		perror(argv[2]);
		exit(127);
		break;
	default:
		signal(SIGALRM, alarmh);
		alarm(to);
		wait(&status);
		break;
	}
	if (WIFSIGNALED(status))
		return 124;
	return WEXITSTATUS(status);
}
